Const ScreenX = 1024
Const ScreenY = 768
Graphics3D ScreenX,ScreenY,16,2

SEEDRND MILLISECS()

Dim Map(0,0)
Global MapW
Global MapH
Global LevelImg = LoadImage("media/level1.bmp") 
Load_level() 
Dim dirMX(3) ;Dimfeld fr X-Verschiebung der 4 Himmelsrichtungen
Dim dirMZ(3) ;Dimfeld fr Z-Verschiebung der 4 Himmelsrichtungen
Global  X_Tile , L_Tile , W_Tile ,  T_Tile , I_Tile , S_Tile ,Ground
Load_Tiles ;Funktionsaufruf nach der Deklaration
Global Pivot = CreatePivot()
Cam = CreateCamera(Pivot)
Global Lab = CreateMesh()
Create_3D_Level()

;Mainloop *******************************************************************************************************************
While Not KeyHit(1)
	RenderWorld
	DrawBlock LevelImg,screenx-200,0
	Flip
Wend
End

Function Load_level() 
   SetBuffer ImageBuffer(levelimg)
   mapw = imagewidth(levelimg)-1
   maph = imageheight(levelimg)-1
   Dim map(MapW,MapH) 
   For y=0 To maph
      For x=0 To mapw
         GetColor x,y 
         If ColorRed() = 0   And ColorGreen() = 0   And ColorBlue() = 0   Then  map(x,y)=1 
      Next 
   Next 
	SetBuffer BackBuffer()
End Function

Function Create_3D_Level()
	For z = 0 To MapH
		For x =  0 To MapW
			If map(x,z) = 1  ;Block setzen
				B.Block = New Block
				;auf Nachbar Block Prfen
  			nCount = 0
  			tString$ = ""
  			xCount = 0
  			zCount = 0
	  		For N = 0 To 3
	  			NX = x+dirMX(N)
	  			NZ = z+dirMZ(N)
  				If offMap(nx,nz) = False Then
  					If map(NX,NZ) = 1 Then ;NAchbar
  						ncount = ncount +1
							Select N
								Case 0
									tString = tstring + "N"
									zCount = zCount +1
								Case 1
									tString = tstring + "O"
									xCount = xCount +1
								Case 2
									tString = tstring + "S"									
									zCount = zCount +1
								Case 3
									tString = tstring + "W"																		
									xCount = xCount +1
							End Select
						EndIf
					EndIf
				Next
			DebugLog "Tile " + x + " " + z + " hat Nachbarn " + nCount +"  " +tstring +" x z count "+ xcount + " " +zcount
				;Auswertung des Tiles
				Select nCount ;Anzahl der Nachbarn
					Case 0				;Eine Sule = S Tile
						b\mesh = CopyMesh(S_Tile)
						b\name = "Saule"																
					Case 1				;Ein Endstck = I  Defaultausrichtung ist w
						b\mesh = CopyMesh(I_Tile)
						b\name = "I Tile"										
						If tString = "N" Then Rotatemesh b\mesh,0,-90,0
						If tString = "O" Then Rotatemesh b\mesh,0,180,0
						If tString = "S" Then Rotatemesh b\mesh,0,+90,0						
					Case 2				;Eine Ecke oder Mauer
						If xCount = 1 And ZCount = 1 Then
							b\mesh = CopyMesh(L_Tile)	;default =sw
							b\name = "L Tile"
							If tString = "NO" Then Rotatemesh b\mesh,0,180,0
							If tString = "OS" Then Rotatemesh b\mesh,0,90,0			
							If tString = "SW" Then Rotatemesh b\mesh,0,0,0			
							If tString = "NW" Then Rotatemesh b\mesh,0,-90,0			
						Else
							b\mesh = CopyMesh(W_Tile)				
							b\name = "W Tile"
							If tString = "NS" Then Rotatemesh b\mesh,0,90,0
						EndIf
					Case 3				;Ein T-Tile
						b\mesh = CopyMesh(T_Tile)  ;Defaultrichtung ist "OSW"
						b\name = "T Tile"
						If tString = "NOS" Then Rotatemesh b\mesh,0,90,0
						If tString = "NOW" Then Rotatemesh b\mesh,0, -180,0
						If tString = "OSW" Then Rotatemesh b\mesh,0, 0,0
						If tString = "NSW" Then Rotatemesh b\mesh,0,-90,0
							
					Case 4				;Ein X Tile
						b\mesh = CopyMesh(X_Tile)	
						b\name = "X Tile"				
				End Select

				PositionMesh b\mesh,x,0,z
  		 	EntityPickMode b\mesh,2
  		 	b\x = x
  		 	b\z = -z
  		 	NameEntity b\mesh, Handle(b)
			 EndIf
		Next
	Next
	
	
	

	For z = 0 To MapH
		For x =  0 To MapW
				Temp = CopyMesh(Ground)			
				PositionMesh Temp,x,0,z
				AddMesh temp,lab
				FreeEntity temp	
		Next
	Next

	For b.block = Each block
		Temp = CopyMesh(b\mesh)			
		AddMesh temp,lab
		HideEntity b\mesh
		FreeEntity temp	
	Next

;Startposition per Zufall bestimmen
.again	
	pX = Rand(1,mapW-1)
	pZ = Rand(1,mapH-1)
	If map(px,pz) = 1 Then Goto again
	PositionEntity pivot,px,2,pz

End Function
	
	

Function Load_Tiles()
	X_Tile = LoadMesh("media\X_tile.b3d")
	L_Tile = LoadMesh("media\L_tile.b3d")
	W_Tile = LoadMesh("media\W_tile.b3d")
	T_Tile = LoadMesh("media\T_tile.b3d")
	I_Tile = LoadMesh("media\I_tile.b3d")
	S_Tile = LoadMesh("media\S_tile.b3d")
	Ground = LoadMesh("media\ground.b3d")

	f# = 1.0
	YScale# = 1.5
	ScaleMesh X_Tile, f,YScale#,f
	ScaleMesh L_Tile, f,YScale#,f
	ScaleMesh W_Tile, f,YScale#,f
	ScaleMesh T_Tile, f,YScale#,f
	ScaleMesh I_Tile, f,YScale#,f
	ScaleMesh S_Tile, f,YScale#,f
	ScaleMesh Ground, f,0,f

	HideEntity X_Tile 
	HideEntity L_Tile 
	HideEntity W_Tile 
	HideEntity T_Tile 
	HideEntity I_Tile 
	HideEntity S_Tile 
	HideEntity Ground

	;Norden
	dirMX(0) = 0
	dirMZ(0) = 1

	;Osten
	dirMX(1) = 1
	dirMZ(1) = 0

	;Sden
	dirMX(2) = 0
	dirMZ(2) = -1

	;Westen
	dirMX(3) = -1
	dirMZ(3) = 0
	
End Function

;nerprft ob die angegebenen Koordinaten noch auf der Map sind-------------------------------------------------------
Function OffMap(X,y)
	If x >MapW Or x < 0 Or y > mapH Or y < 0 Then Return True
	Return False
End Function

Type Block
	Field mesh
	Field Name$
	Field x,z
End Type