AppTitle "Konvertieren von Bitmaps zu 3D Leveln by Bob Mrz 2006"

Const ScreenX = 1024
Const ScreenY = 768
Const Key_Up 	   = 200
Const Key_Left   = 203
Const Key_Right  = 205


Graphics3D ScreenX,ScreenY,16,2
Include "include\b3dfile.bb"
Include "include\write_b3d.bb"

SEEDRND MILLISECS()

Dim Map(0,0)
Global MapW
Global MapH
Global LevelImg = LoadImage("media/level1.bmp");el1.bmp") 
Load_level() 
Dim dirMX(3) ;Dimfeld fr X-Verschiebung der 4 Himmelsrichtungen
Dim dirMZ(3) ;Dimfeld fr Z-Verschiebung der 4 Himmelsrichtungen
Global  X_Tile , L_Tile , W_Tile ,  T_Tile , I_Tile , S_Tile ,Ground
Load_Tiles ;Funktionsaufruf nach der Deklaration
Global Pivot = CreatePivot()
Cam = CreateCamera(Pivot)
Global Lab = CreateMesh()
Create_3D_Level()


Global Moving = False
Global Turning = False
Global FPSSEC = MilliSecs(), FPS, FRAMES 	

CameraZoom cam,1.5
CameraRange cam,0.1,20
CameraClsColor cam, 0,0,0;9,11,15
camerafogmode cam,1
CameraFogRange cam, -3,15
CameraFogColor cam, 0,0,0;7,46,46


Global LevelBackup = CopyImage(LevelImg)
TFormFilter 0
ScaleImage  LevelBackup,2,2

Fackel =createlight(2,pivot)
PositionEntity Fackel,0,1,0
LightColor Fackel,251,240,168
LightRange Fackel, 10
Fackeltime = MilliSecs()
AmbientLight 0,0,0

Global OX = EntityX(pivot)
Global OZ = EntityX(pivot)
Global cstep

ScaleImage LevelImg,2,2

;Ein Kompass-------------------------------------------------------------
kompass = LoadSprite("media/kompass.bmp",2,pivot)
PositionEntity kompass,0,0.75,2
EntityOrder kompass,-1
ScaleSprite kompass,0.25,0.25
Global nadel =LoadSprite ("media/kompass_nadel.bmp",2,kompass)
ScaleSprite nadel,0.25,0.25
EntityOrder nadel,-2
EntityFX kompass,1+8		;Leuchtend + Kein Nebel
EntityFX nadel,1+8
SpriteViewMode nadel,2

Dim Sound(7)
init_Sounds()
global wChn		   ;Fr Wlaksound Steuerung

loopsound(sound(0))
PlaySound(sound(0))

;Mainloop *******************************************************************************************************************
While Not KeyHit(1)
	If KeyHit(88) Then
		Cls
		Flip
		Color 255,255,255
		Locate ScreenX/ 2-100, ScreenY/2-10
		filename$ = Input("Dateiname fr b3d File? " )
		If filename <> "" Then
			ChangeDir "media"
			WriteBB3D(filename,LAB)
			flushkeys
		EndIf
	EndIf
	
	If MilliSecs()> Fackeltime then
		fackeltime = MilliSecs() + Rand(30,40)
		LightRange Fackel, Rnd(8.0,10.0)
		LightColor Fackel,rand(240,260),rand(230,250),rand(160,170)
	EndIf

	Cam_Control
	RenderWorld
	DrawBlock Levelimg,screenx-200,0
	;Text 0,0, "FPS: "+FPS(1)
	;Text 0,20, "Aktuelle Position: "+entityx(pivot)+ "|" + EntityZ(pivot)
	Flip 
Wend
End
;Mainloop ENDE ***************************************************************************************************************


Function Load_Level()
   ScaleImage Levelimg, 1,-1
   SetBuffer ImageBuffer(Levelimg)
   mapw = imagewidth(Levelimg)-1
   maph = imageheight(Levelimg)-1
   Dim map(MapW,MapH) 
   For y=0 To maph
      For x=0 To mapw
         GetColor x,y 
         If ColorRed() = 0 And ColorGreen() = 0 And ColorBlue() = 0 Then  map(x,y)=1 
      Next 
   Next 
	SetBuffer BackBuffer()
  ScaleImage Levelimg, 1,-1
End Function

Function Create_3D_Level()
	For z = 0 To MapH
		For x =  0 To MapW
			If map(x,z) = 1  ;Block setzen
				B.Block = New Block
				;auf Nachbar Block Prfen
  			nCount = 0
  			tString$ = ""
  			xCount = 0
  			zCount = 0
	  		For N = 0 To 3
	  			NX = x+dirMX(N)
	  			NZ = z+dirMZ(N)
  				If offMap(nx,nz) = False Then
  					If map(NX,NZ) = 1 Then ;NAchbar
  						ncount = ncount +1
							Select N
								Case 0
									tString = tstring + "N"
									zCount = zCount +1
								Case 1
									tString = tstring + "O"
									xCount = xCount +1
								Case 2
									tString = tstring + "S"									
									zCount = zCount +1
								Case 3
									tString = tstring + "W"																		
									xCount = xCount +1
							End Select
						EndIf
					EndIf
				Next
			DebugLog "Tile " + x + " " + z + " hat Nachbarn " + nCount +"  " +tstring +" x z count "+ xcount + " " +zcount
				;Auswertung des Tiles
				Select nCount ;Anzahl der Nachbarn
					Case 0				;Eine Sule = S Tile
						b\mesh = CopyMesh(S_Tile)
						b\name = "Saule"																
					Case 1				;Ein Endstck = I  Defaultausrichtung ist w
						b\mesh = CopyMesh(I_Tile)
						b\name = "I Tile"										
						If tString = "N" Then Rotatemesh b\mesh,0,-90,0
						If tString = "O" Then Rotatemesh b\mesh,0,180,0
						If tString = "S" Then Rotatemesh b\mesh,0,+90,0						
					Case 2				;Eine Ecke oder Mauer
						If xCount = 1 And ZCount = 1 Then
							b\mesh = CopyMesh(L_Tile)	;default =sw
							b\name = "L Tile"
							If tString = "NO" Then Rotatemesh b\mesh,0,180,0
							If tString = "OS" Then Rotatemesh b\mesh,0,90,0			
							If tString = "SW" Then Rotatemesh b\mesh,0,0,0			
							If tString = "NW" Then Rotatemesh b\mesh,0,-90,0			
						Else
							b\mesh = CopyMesh(W_Tile)				
							b\name = "W Tile"
							If tString = "NS" Then Rotatemesh b\mesh,0,90,0
						EndIf
					Case 3				;Ein T-Tile
						b\mesh = CopyMesh(T_Tile)  ;Defaultrichtung ist "OSW"
						b\name = "T Tile"
						If tString = "NOS" Then Rotatemesh b\mesh,0,90,0
						If tString = "NOW" Then Rotatemesh b\mesh,0, -180,0
						If tString = "OSW" Then Rotatemesh b\mesh,0, 0,0
						If tString = "NSW" Then Rotatemesh b\mesh,0,-90,0
							
					Case 4				;Ein X Tile
						b\mesh = CopyMesh(X_Tile)	
						b\name = "X Tile"				
				End Select

				PositionMesh b\mesh,x,0,z
  		 	EntityPickMode b\mesh,2
  		 	b\x = x
  		 	b\z = -z
  		 	NameEntity b\mesh, Handle(b)
			 EndIf
		Next
	Next
	
	
	

	For z = 0 To MapH
		For x =  0 To MapW
				Temp = CopyMesh(Ground)			
				PositionMesh Temp,x,0,z
				AddMesh temp,lab
				FreeEntity temp	
		Next
	Next

	For b.block = Each block
		Temp = CopyMesh(b\mesh)			
		AddMesh temp,lab
		HideEntity b\mesh
		FreeEntity temp	
	Next

	
	;Startposition per Zufall bestimmen
.again	
	pX = Rand(1,mapW-1)
	pZ = Rand(1,mapH-1)
	If map(px,pz) = 1 Then Goto again
	PositionEntity pivot,px,2,pz
	

End Function


Function Load_Tiles()
	X_Tile = LoadMesh("media\X_tile.b3d")
	L_Tile = LoadMesh("media\L_tile.b3d")
	W_Tile = LoadMesh("media\W_tile.b3d")
	T_Tile = LoadMesh("media\T_tile.b3d")
	I_Tile = LoadMesh("media\I_tile.b3d")
	S_Tile = LoadMesh("media\S_tile.b3d")
	Ground = LoadMesh("media\ground.b3d")

	f# = 1.0
	YScale# = 1.5
	ScaleMesh X_Tile, f,YScale#,f
	ScaleMesh L_Tile, f,YScale#,f
	ScaleMesh W_Tile, f,YScale#,f
	ScaleMesh T_Tile, f,YScale#,f
	ScaleMesh I_Tile, f,YScale#,f
	ScaleMesh S_Tile, f,YScale#,f
	ScaleMesh Ground, f,0,f

	HideEntity X_Tile 
	HideEntity L_Tile 
	HideEntity W_Tile 
	HideEntity T_Tile 
	HideEntity I_Tile 
	HideEntity S_Tile 
	HideEntity Ground

	;Norden
	dirMX(0) = 0
	dirMZ(0) = 1

	;Osten
	dirMX(1) = 1
	dirMZ(1) = 0

	;Sden
	dirMX(2) = 0
	dirMZ(2) = -1

	;Westen
	dirMX(3) = -1
	dirMZ(3) = 0
	
End Function

;Camera Steuerung-------------------------------------------------------------------------------------------
Function Cam_Control()

	If Moving = True Or Turning <> 0 Then
		If Turning <> 0 Then
			TurnEntity pivot,0,-(Turning*5),0
			TurnEntity nadel,0,0, -(Turning*5)
			cStep = cStep +5
			If cStep = 90 Then
				Turning = 0
				cStep = 0
				PlaySound(sound(rand(4,7)))
									
			EndIf
		EndIf

		If Moving Then
			MoveEntity pivot,0,0,.1
			cStep = cStep +1
			wCHN = wChn +1
			If wChn >= 20 then
		 		playSound(sound(rand(4,7)))
		 		wchn = 0
			EndIf				
			If cStep = 10 Then
				moving = False
				cStep = 0
				px = Entityx(pivot)
				pz = Entityz(pivot)
				PositionEntity pivot,px,2,pz
				If map(px,pz) = 1 Then 
					PositionEntity pivot,ox,2,oz
					PlaySound(sound(rand(1,3)))
				Else
					ox = px
					oz = pz
					LevelImg = CopyImage(LevelBackup)
					SetBuffer ImageBuffer(LevelImg)
					Color 255,0,0
					Rect (ox*2) -2,(200 - oz*2)-2,4,4
					Color 255,255,255
					SetBuffer BackBuffer()
				EndIf
				
			EndIf
		endif
		Return
	EndIf

	If KeyDown(Key_Right)	 = True Then Turning = 1 :return
	If KeyDown(Key_Left)	 = True Then Turning = -1 :return
	If KeyDown(Key_Up)		 = True Then moving = True :return
End function



;nerprft ob die angegebenen Koordinaten noch auf der Map sind-------------------------------------------------------
Function OffMap(X,y)
	If x >MapW Or x < 0 Or y > mapH Or y < 0 Then Return True
	Return False
End function

Type Block
	Field mesh
	Field Name$
	Field x,z
End Type

Function Init_Sounds()
	sound(0) = LoadSound("media\ambient.mp3")
	sound(1) = LoadSound("media\grond_hit1.wav")
	sound(2) = LoadSound("media\grond_hit2.wav")
	sound(3) = LoadSound("media\grond_hit3.wav")
	sound(4) = LoadSound("media\walk1.wav")
	sound(5) = LoadSound("media\walk2.wav")
	sound(6) = LoadSound("media\walk3.wav")
	sound(7) = LoadSound("media\walk4.wav")	

End Function
;Berechnet die FPS
Function FPS(MODE) ;----------------------------------------------------------------------------
	If MODE = 1 Then 
		FRAMES = FRAMES + 1 
		If MilliSecs() - FPSSEC => 1000 Then 
			FPS = FRAMES 
			FRAMES = 0 
			FPSSEC = MilliSecs() 
		EndIf 
	EndIf 
	Return FPS 
End Function